import { RouterGuardService } from "./router-guard-service";
export class RouterGuardsService {
    constructor({ to, from }) {
        this.beforeEach = new RouterGuardService(to, from);
        this.beforeResolve = new RouterGuardService(to, from);
        this.afterEach = new RouterGuardService(to, from, true);
        this.setRoutes(to, from);
    }
    addBeforeEach(callback) {
        this.beforeEach.add(callback);
    }
    addBeforeResolve(callback) {
        this.beforeResolve.add(callback);
    }
    addAfterEach(callback) {
        this.afterEach.add(callback);
    }
    runBeforeEach() {
        return this.beforeEach.run();
    }
    runBeforeResolve() {
        return this.beforeResolve.run();
    }
    runAfterEach() {
        this.afterEach.run();
    }
    setRoutes(to, from) {
        this.beforeEach.setRoutes(to, from);
        this.beforeResolve.setRoutes(to, from);
        this.afterEach.setRoutes(to, from);
    }
}
//# sourceMappingURL=router-guards-service.js.map